SystemOrganization addCategory: #J!

!ByteString methodsFor: '*J' stamp: 'HwaJong 12/24/2012 22:09'!
compileJ
	 '?. 20 $ 100' = self ifTrue: [^((Random new next: 20) * 100) collect: #truncated].
	^self substrings.! !

!Matrix methodsFor: '*J' stamp: 'HwaJong 12/24/2012 22:35'!
collectJ: anArray rank: aSmallInteger 
	^self rows collect: [:each| anArray doJ: each]! !

!Array methodsFor: '*J' stamp: 'HwaJong 12/24/2012 22:07'!
doJ: anArray 
	| coll |
	coll := self collect: [:op| (op beginsWith: '#') ifTrue: [anArray perform: op allButFirst asSymbol  ] ifFalse: [op]].
	^coll second = '/'
		ifTrue: [coll first / coll third]
		ifFalse: [coll]! !

Object subclass: #JTensor
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'dimension contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'J'!

JTensor class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!JTensor classSide methodsFor: 'instance creation' stamp: 'HwaJong 12/24/2012 22:44'!
dimension: anArray randomInt: anInteger
	| r |
	r := Random new.
	^self new dimension: anArray; contents: (anArray product timesCollect: [r nextInt: anInteger]).! !

!JTensor classSide methodsFor: 'instance creation' stamp: 'HwaJong 12/25/2012 01:12'!
i: anArray 
	^self new dimension: anArray; contents: (0 to: anArray product-1)! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/25/2012 22:39'!
at: anArray
	|mq |
	mq := MultiQuoAndRem new.
	mq dividers: dimension.
	^contents at: (mq unIndexValue: anArray).! !

!JTensor methodsFor: 'enumerating' stamp: 'HwaJong 12/25/2012 01:22'!
collect: aBlockClosure
	^self class new
		dimension: dimension copy;
		contents: (contents collect: aBlockClosure)  
	! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/25/2012 01:00'!
contents
	^ contents! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/24/2012 22:41'!
contents: aSequenceableCollection 
	contents := aSequenceableCollection! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/25/2012 01:00'!
dimension
	^ dimension! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/24/2012 22:40'!
dimension: anArray 
	dimension := anArray! !

!JTensor methodsFor: 'private' stamp: 'HwaJong 12/25/2012 01:00'!
gettersForEquality
	^#(dimension contents)! !

!JTensor methodsFor: 'testing' stamp: 'HwaJong 12/24/2012 22:41'!
isDimensionCorrect
	^dimension product = contents size! !

!JTensor methodsFor: 'self evaluating' stamp: 'HwaJong 12/25/2012 00:57'!
rank: rankInteger 
	|leftDimension streams mq|
	leftDimension := (dimension copyFrom: 1 to: rankInteger-1), (dimension copyFrom: rankInteger+1 to: dimension size).
	mq := MultiQuoAndRem new.
	mq dividers: dimension.
	streams := (dimension at: rankInteger) timesCollect: [WriteStream on: (Array new: leftDimension product)].
	contents keysAndValuesDo: [:k :v| 
		| res |
		res := mq value: k-1.
		(streams at: ((res at: 1+rankInteger)+1)) nextPut: v ].
	^streams collect: [:st| JTensor new dimension: leftDimension copy; contents: st contents]! !

!JTensor methodsFor: 'self evaluating' stamp: 'HwaJong 12/25/2012 01:28'!
sum
	^contents sum! !

Object subclass: #JVerb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'J'!
